
#include "io430.h"

void lightOn()
{
  P1OUT |= 1;
  //P1OUT_bit.P0 = 1; //bit field
}

void lightOff()
{
  P1OUT &= ~1;
  //P1OUT_bit.P0 = 0; //bit field
}

void wait(int z)
{
  for(long i = 0; i < 2000L * z; i++) // schlecht; verwende Timer!
  {
  }
}

int main( void )
{
  // Stop watchdog timer to prevent time out reset
  WDTCTL = WDTPW + WDTHOLD;

  P1DIR |= 1;
  
  struct MorseCode
  {
    char character;
    signed char code[9];
  };
  typedef struct MorseCode MorseCode;
  
  //int a[] = {1, 2, 3}; als Beispiel fr Syntax
  MorseCode dictionary[] =      // effizienter gespeichert mit "static const" davor
  {
    {'A', {1, -1, 3, -3}},
    {'E', {1, -3}},
    {'H', {1, -1, 1, -1, 3, -1, 1, -3}},
    {'L', {1, -1, 3, -1, 1, -1, 1, -3}},
    {'O', {3, -1, 3, -1, 3, -3}},
    {'T', {3, -3}},
    {'W', {1, -1, 3, -1, 3, -3}},
    {' ', {-4}}  
  };
  
  char text[] = "HALLO WELT";
  for(int i = 0; text[i] != 0; i++)
  {
    int j;
    for(j = 0; dictionary[j].character != text[i]; j++)
    {}
    for(int k = 0; dictionary[j].code[k] != 0; k++)
    {
      signed char z = dictionary[j].code[k];
      if(z > 0)
      {
        lightOn();
      }
      else
      {
        lightOff();
        z = -z;
      }
      wait(z);
    }
  }
      
  return 0;
}
